Python scripting tutorial

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Python scripting tutorial and the translation is 59% complete.

Outdated translations are marked like this.
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎português • ‎română • ‎русский • ‎Türkçe • ‎中文(中国大陆)‎

Base ExampleCommandModel.png Tutorial

Tema
Programming
Nivel
Intermediate
Tiempo para completar
Autor
Versión de FreeCAD
Archivo(s) de ejemplo(s)



Python es un lenguaje de programación, muy simple de utilizar y muy rápido de aprender. Es de código libre, multi plataforma, y puede utilizarse para una gran variedad de cosas, desde la programación de archivos de guión simples a programas muy complejos. Pero uno de sus usos más extendidos es como lenguaje de archivos de guión, ya que es sencillo de embeber en otras aplicaciones. Así es exactamente como se utiliza dentro de FreeCAD. Desde la consola de Python, o desde tus archivos de guión personalizados, puedes pilotar FreeCAD, y hacer que ejecute acciones muy complejas para las cuales aún no exista herramientas en la interfaz gráfica de usuario.

Por ejemplo, desde un archivo de guión de Python, puedes:

  • Crear nuevos objetos.
  • Modificar los objetos existentes.
  • Modificar la representación 3D de dichos objetos
  • Modificar la interfaz de FreeCAD

También existen diversas formas de utilizar Python en FreeCAD:

  • Desde el Interprete de Python de FreeCAD, donde puedes dictar comandos como en una interfaz del tipo de línea de comandos
  • Desde Macros, que son una forma conveniente de añadir una herramienta que no exista a la interfaz de FreeCAD
  • Desde archivos de guión externos, que pueden utilizarse para programar cosas mucho más complejas. Como Entornos completos.

En este tutorial, trabajaremos en varios ejemplos simples para que puedas iniciarte, pero existe mucha más documentación sobre los archivos de guión de Python disponible en esta wiki. Si eres totalmente nuevo en Python y quieres comprender cómo funciona, también tenemos una básica Introducción a Python.

Important! Before proceeding with Python scripting, go to Edit → Prefences → General → Output window and check 2 boxes:

  • Redirect internal Python output to report view
  • Redirect internal Python errors to report view

Then go to View → Panels and check:

  • Report view

This will save you a lot of aggravation!

Escribiendo código en Python

Existen dos modos sencillos de escribir código de Python en FreeCAD: Desde la consola de Python (disponible en el menú Vista -> Vistas -> Consola de Python) o desde el editor de macros (Herramientas -> Macros). En la consola, escribes comandos de Python uno a uno, que son ejecutados al presionar Enter, mientras que las macros pueden contener archivos de guión más completos formados por varias líneas, que se ejecutan sólo cuando la macro es ejecutada.

La consola de Python de FreeCAD

En este tutorial, serás capaz de utilizar ambos métodos, ya sea copiando y pegando cada línea una a una en la consola de Python y presionando Return después de cada línea, o copiando y pegando el código entero en una ventana de macro nueva.

Explorando FreeCAD

Vamos a empezar creando un nuevo documento vacío:

doc = FreeCAD.newDocument()

Si escribes esto en la consola de Python de FreeCAD, notaras que en cuanto escribas "FreeCAD.", una ventana aparece, permitiendo rápidamente autocompletar el resto de la línea. Aún mejor, cada entrada en la lista de autocompletar tiene una ayuda explicando lo que hace. Esto hace muy sencillo explorar las funcionalidades disponibles. Antes de seleccionar "newDocument", mira las otras opciones disponibles.

El mecanismo de autocompletar de la consola de Python de FreeCAD

Ahora nuestro nuevo documento se creará. Esto es similar a presionar el botón "Nuevo documento" en la barra de herramientas. En realidad, la mayoría de botones en FreeCAD no hacen nada más que ejecutar una línea o dos de código en Python. Aún mejor, puedes establecer una opción en Editar -> Preferencias -> General -> Macro para "mostrar los comandos de los archivos de guión en la consola de Python". Esto mostrará en la consola todo el código de Python ejecutado cuando presionas los botones. Muy útil para aprender como reproducir acciones en Python.

Volvamos ahora a nuestro documento. Vamos a ver que podemos hacer con él:

doc.

Explora las opciones disponibles. Normalmente los nombres que comienzan con una letra mayúscula son atributos, que contienen un valor, mientras que los nombres que empiezan con una letra minúscula son funciones (también llamados métodos), que hacen "algo". Los nombres que comienzan con un guión bajo están ahí normalmente para el funcionamiento interno del módulo, y no deberías preocuparte de ellos. Vamos a utilizar uno de los métodos para añadir un nuevo objeto a nuestro documento:

box = doc.addObject("Part::Box","myBox")

No pasa nada. Por qué? Es debido a que FreeCAD está pensado para realizar trabajos complejos. Un día, trabajará con cientos de objetos complejos, todos dependiendo unos de otros. Hacer un pequeño cambio en cualquier parte podría tener un gran impacto,necesitaras recalcular el documento completo, que puede llevar bastante tiempo... Por ese motivo, casi ningún comando actualiza la escena automáticamente. Debes hacerlo manualmente:

doc.recompute()

Ves? Ahora aparece nuestro cubo! Muchos de los botones que añaden objetos en FreeCAD en realidad hacen dos cosas: Añadir el objeto, y recalcular. Si activas la opción "mostrar los comandos de los archivos de guión en la consola de Python", prueba a añadir una esfera con el botón de la interfaz, verás las dos líneas de código de Python siendo ejecutadas una tras la otra.

Qué quieres saber sobre el "Part::Box"? Cómo puedo saber que otros tipos de objetos puedo añadir? Está todo aquí:

doc.supportedTypes()

Ahora vamos a explorar el contenido de nuestro cubo:

box.

Verás automáticamente varias cosas interesantes como:

box.Height

Esto mostrará la altura actual de nuestro cubo. Ahora vamos a intentar cambiarla:

box.Height = 5

Si seleccionas tu cubo con el ratón, verás que en el panel de propiedades, en la pestaña de "Datos", nuestra propiedad "Height" aparece. Todas las propiedades de un objeto de FreeCAD que aparecen aquí (y también en la pestaña "Vista", de la que hablaremos más adelante), son directamente accesibles también desde Python, por sus nombres, como hicimos con la propiedad "Height". Prueba cambiando las otras dimensiones del cubo.

Vectores y ubicaciones

Los vectores son un concepto muy fundamental en cualquier aplicación 3D. Son una lista de 3 números (X, Y y Z), describiendo un punto o posición en el espacio 3D. Un montón de cosas se pueden hacer con los vectores, como sumas, restas, proyecciones y mucho más. En FreeCAD los vectores funcionan así:

myvec = FreeCAD.Vector(2,0,0)
myvec
myvec.x
myvec.y
othervec = FreeCAD.Vector(0,3,0)
sumvec = myvec.add(othervec)

Otra característica de los objetos de FreeCAD es su ubicación. Cada objeto tiene atributos de Ubicación, que contienen la posición (Base) y orientación (Rotación) del objeto. Son sencillos de manejar, por ejemplo para mover nuestro objeto:

box.Placement
box.Placement.Base
box.Placement.Base = sumvec
 
otherpla = FreeCAD.Placement()
box.Placement = otherpla

Ahora deberías comprender varios conceptos importantes antes de continuar avanzando.

App y Gui

FreeCAD está creado desde el principio para ser una aplicación de línea de comando, sin su interfaz de usuario. Como resultado, prácticamente todo está separado entre una componente "geométrica" y una componente "visual". Cuando trabajas en modo línea de comando, la parte geométrica está presente, pero todas las partes visuales están sencillamente desactivadas. Prácticamente cualquier objeto en FreeCAD por lo tanto está formado por dos partes, un Object y un ViewObject.

Para ilustrar el concepto, mira nuestro objeto cubo, las propiedades geométricas del cubo, como sus dimensiones, posición, etc. son almacenadas en el Objeto, mientras que sus propiedades visuales, como su color, espesor de línea, etc. se almacenan en el viewobject. Esto se corresponde con las pestañas "Datos" y "Vista" en la ventana de propiedades. El viewobject de un objeto es accesible así:

vo = box.ViewObject

Ahora también puedes cambiar las propiedades de la pestaña "Vista":

vo.Transparency = 80
vo.hide()
vo.show()

Cuando inicias FreeCAD, la consola de Python carga 2 módulos base: FreeCAD y FreeCADGui (que también son accesibles por sus diminutivos App y Gui). Ellos contienen toda clase de funcionalidades genéricas para trabajar con documentos y sus objetos. Para ilustrar nuestro concepto, observa que ambos FreeCAD y FreeCADGui contienen un atributo ActiveDocument, el cual es el documento abierto actualmente. FreeCAD.ActiveDocument y FreeCADGui.ActiveDocument no son el mismo objeto. Son los dos componentes de un documento de FreeCAD, y contienen diferentes atributos y métodos. Por ejemplo, FreeCADGui.ActiveDocument contiene ActiveView, que es la vista 3D abierta actualmente.

Módulos

Seguramente te debes estar preguntando, Qué más que puedo hacer además del "Part::Box"? La aplicación base de FreeCAD es más o menos un contenedor vacío. Sin sus módulos, puede hacer poco más que crear nuevos documentos vacíos. La verdadera potencia de FreeCAD está en sus fieles módulos. Cada uno de ellos añade no sólo nuevos entornos a su interfaz, sino también nuevos comandos de Python y nuevos tipos de objetos. Como resultado, varios tipos de objetos diferentes o incluso totalmente incompatibles pueden coexistir en el mismo documento. Los módulos más importantes en FreeCAD, que veremos en este tutorial, son Piezas, Mallas, Croquizador o Boceto.

Los módulos Croquizador y Boceto ambos utilizan el módulo Piezas para crear y manejar sus geometrías, las cuales son mientras que el módulo Mallas es totalmente independiente, y maneja sus propios objetos. Comentaremos algo más en adelante.

Puedes comprobar todos los tipos de objeto base disponibles para el documento actual así:

doc.supportedTypes()

Los diferentes módulos de FreeCAD, aunque añaden sus propios tipos de objeto a FreeCAD, no se cargan automáticamente en la consola de Python. Esto se hace para evitar un inicio demasiado lento. Los módulos son cargados sólo cuando los necesitas. Así, por ejemplo, para explorar que es lo que hay en el módulo de Piezas:

import Part
Part.

Pero ya hablaremos más adelante del módulo de Piezas.

Por ahora, sabes un poco más sobre los diferentes módulos de FreeCAD: Los módulos principales (FreeCAD, FreeCADGui), y los módulos de los entornos (Part, Mesh, Sketcher). Otros módulos importantes son el módulo de la escena 3D (pivy) y el módulo de la interfaz (pyqt), también hablaremos de ellos más adelante.

Ahora es momento de explorar un poco más en profundidad los importantes, que son los módulos de los entornos.

Mallas

Las Mallas son un tipo de objeto 3D muy simple, utilizados por ejemplo por Sketchup, Blender o 3D studio Max. Están compuestos por 3 elementos: puntos (también denominados vértices), líneas (también denominadas aristas) y caras. En numerosas aplicaciones, FreeCAD incluida, las caras sólo pueden tener 3 vértices. Pero por supuesto nada impide que tengas una cara plana mayor formada por diversas caras triangulares coplanares.

Las mallas son simple, esto puede ser un mal asunto, pero para muchas aplicaciones como las citadas antes, se vuelve en una ventaja, porque son tan simples que puedes fácilmente tener millones de ellas en un único documento. Aunque en FreeCAD tienen poca utilidad, y se utilizan principalmente para que puedas importar objetos en formato de malla (.stl, .obj) de otras aplicaciones. También fue utilizado extensamente como el módulo de test principal en el primer mes de vida de FreeCAD.

Los objetos de malla y los objetos de FreeCAD son cosas diferentes. Puedes ver el objeto de FreeCAD como un contenedor para un objeto de malla (como, veremos más adelante, también para objetos de pieza). Así que para añadir un objeto de malla a FreeCAD, debemos primero crear un objeto de FreeCAD y un objeto de malla, después añadir el objeto de malla al objeto de FreeCAD:

import Mesh
mymesh = Mesh.createSphere()
mymesh.
mymesh.Facets
mymesh.Points
 
meshobj = doc.addObject("Mesh::Feature","MyMesh")
meshobj.Mesh = mymesh
doc.recompute()

Este es un ejemplo estándar, que utiliza el método createSphere() para automáticamente crear una esfera, pero podrías perfectamente crear objetos de malla personalizados desde cero, definiendo sus vértices y caras.

Lee más sobre utilizar código con las mallas...

Piezas

El Módulo de Piezas es el módulo más potente de todo FreeCAD. Permite crear y manejar objetos BRep. Este tipo de objetos, a diferencia de las mallas, pueden tener una amplia variedad de componentes. Para resumir un poco, Brep significa Boundary Representation, que quiere decir que están definidos por sus superficies, que comprenden y definen un volumen interior. Dichas superficies pueden ser varias cosas, como caras planas o superficies NURBS complejas. También incorporan el concepto de volumen.

El módulo de Piezas está basado en la potente tecnología de la librería OpenCasCade, que permite que un amplio rango de operaciones complejas sean aplicadas de forma sencilla en dichos objetos, como las operaciones booleanas, redondeos, barridos...

El módulo de Piezas funciona del mismo modo que el módulo de mallas: Se crea un objeto de FreeCAD, un objeto de Pieza, luego añadir el objeto de pieza al objeto de FreeCAD:

import Part
myshape = Part.makeSphere(10)
myshape.
myshape.Volume
myshape.Area

shapeobj = doc.addObject("Part::Feature","MyShape")
shapeobj.Shape = myshape
doc.recompute()

El módulo de Piezas (como el módulo de mallas) también tiene un atajo que automáticamente crea un objeto de FreeCAD y le añade una forma, así puedes evitar las tres líneas anteriores:

Part.show(myshape)

Explorando el contenido de myshape, observarás que están disponibles varios subcomponentes interesantes como caras, aristas, vértices, sólidos o superficies, y un amplio rango de operaciones geométricas como cortes (sustracciones), común (intersecciones) o fusiones (unión). La página de Archivos de guión de topología de datos lo explica todo detalladamente.

Lee más sobre utilizar código con las piezas...

Boceto

FreeCAD proporciona varios módulos, como el Croquizador o Boceto, que también crean objetos de piezas, pero le añade parámetros, o incluso un nuevo modo de manejar la geometría de las piezas. Nuestro cubo de ejemplo de arriba, es un perfecto ejemplo de objeto paramétrico. Todo lo que necesitas, para definir el cubo, es especificar un conjunto de parámetros, como las altura, ancho y longitud. Basados en los cuales, el objeto calculará automáticamente su forma de Pieza. FreeCAD te permite crear dichos objetos en Python.

El Módulo de Boceto añade diversos tipos de objetos 2D paramétricos (que son todos objetos de Piezas) como líneas y circunferencias, y también proporciona algunas funciones genéricas que funcionan no sólo en objetos creados en el módulo de Boceto, sino en cualquier objeto de Pieza. Para explorar lo que está disponible, simplemente haz lo siguiente:

import Draft
Draft.
rec = Draft.makeRectangle(5,2)
mvec = FreeCAD.Vector(4,4,0)
Draft.move(rec,mvec)
Draft.move(box,mvec)

Interfaz

La interfaz de usuario de FreeCAD está creada con Qt, un poderoso sistema de interfaces gráficas, responsable de dibujar y manejar todos los controles, menús, barras de herramientas y botones en toda la vista 3D. Qt proporciona un módulo, denominado PyQt, que permite a Python acceder y modificar interfaces Qt, como la de FreeCAD. Vamos a tratar de lidiar con la interfaz de Qt y producir un letrero de diálogo simple:

from PySide import QtGui
QtGui.QMessageBox.information(None,"Apollo program","Houston, we have a problem")

Observa que el letrero de diálogo que aparece tiene el icono de FreeCAD en su barra de herramientas, lo que significa que Qt sabe que el comando ha sido ejecutado desde la aplicación FreeCAD. Podemos por lo tanto manipular directa y sencillamente cualquier parte de la interfaz de FreeCAD.

Qt es un sistema de interfaces muy potente, que te permite hacer cosas muy complejas, pero también dispone de varias herramientas de uso muy sencillo como el Qt Designer con el cual puedes diseñar letreros de diálogo graficamente y después añadirlos a la interfaz de FreeCAD con un par de líneas en Python.

Macros

Ahora que tienes una buena comprensión de los conceptos básicos, a dónde vamos para mantener nuestros archivos de guión en Python, y cómo vamos a ejecutarlos fácilmente desde FreeCAD? Existe un sencillo mecanismo para ello, denominado Macros. Una macro es simplemente un archivo de guión en Python, que puede ser añadida a una barra de herramientas y lanzada desde un simple clic de ratón. FreeCAD proporciona un simple editor de textos (Macro -> Macros -> Crear) donde puedes escribir o pegar archivos de guión. Una vez esté terminado, Herramientas -> Personalizar -> Macros te permite definir un botón para ella, que se puede añadir a las barras de herramientas.

Ahora estas listo para ver más en profundidad los archivos de guión en FreeCAD. Dirígete al Centro de usuarios avanzados!